﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Entidades;

namespace Datos
{
    public class PerfilDA : BaseDades, IDataAcces<Perfil>
        {
            #region Miembros de IDataAccess<Perfil>

            //funció per a obtenir tots els perfils dels usuaris
            public List<Perfil> GetAll()
            {
                DataClasses1DataContext dc = GetDC();
                IQueryable<Perfil> query = from perfil
                                               in dc.Perfil
                                               select perfil;
                return ConsultaLista<Perfil>(query);
            }

            //funció per afegir un nou perfil
            public void Adicionar(Perfil item)
            {
                DataClasses1DataContext dc = GetDC();
                dc.Perfil.InsertOnSubmit(item);
                dc.SubmitChanges();
            }
            
            //funció per eliminar un perfil
            public void Eliminar(Perfil item)
            {
                DataClasses1DataContext dc = GetDC();
                dc.Perfil.Attach(item);
                dc.Perfil.DeleteOnSubmit(item);
                dc.SubmitChanges();
            }

            //funció per actualitzar un perfil
            public void Actualizar(Perfil nuevoItem, Perfil originalItem)
            {
                DataClasses1DataContext dc = GetDC();
                dc.Perfil.Attach(nuevoItem, originalItem);
                dc.SubmitChanges();
            }
        }
            #endregion
 }