﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Entidades;

namespace Datos
{
    public class TematicaDA : BaseDades, IDataAcces<Tematica>
    {
            //funció que llista totes les temàtiques de la bbdd
            public List<Tematica> GetAll()
            {
                DataClasses1DataContext dc = GetDC();
                IQueryable<Tematica> query = from tematica
                                               in dc.Tematica
                                               orderby tematica.descripcio
                                               select tematica;
                return ConsultaLista<Tematica>(query);
            }

            //funció per afegir una nova temàtica
            public void Adicionar(Tematica item)
            {
                DataClasses1DataContext dc = GetDC();
                dc.Tematica.InsertOnSubmit(item);
                dc.SubmitChanges();
            }
            
            //funció per eliminar una temàtica
            public void Eliminar(Tematica item)
            {
                DataClasses1DataContext dc = GetDC();
                dc.Tematica.Attach(item);
                dc.Tematica.DeleteOnSubmit(item);
                dc.SubmitChanges();
            }

            //funció per actualitzar una temàtica
            public void Actualizar(Tematica nuevoItem, Tematica originalItem)
            {
                DataClasses1DataContext dc = GetDC();
                dc.Tematica.Attach(nuevoItem, originalItem);
                dc.SubmitChanges();
            }
        }
}