﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Entidades;

namespace Datos
{
    public class TipusDA : BaseDades, IDataAcces<Tipus>
        {
            #region Miembros de IDataAccess<Tipus>
            //funció per obtenir tots els tipus de publicacions
            //0=text només, 1 = imatge, 2 = video
            public List<Tipus> GetAll()
            {
                DataClasses1DataContext dc = GetDC();
                IQueryable<Tipus> query = from tipus
                                               in dc.Tipus
                                               select tipus;
                return ConsultaLista<Tipus>(query);
            }
            
            //fució per afegir un nou tipus
            public void Adicionar(Tipus item)
            {
                DataClasses1DataContext dc = GetDC();
                dc.Tipus.InsertOnSubmit(item);
                dc.SubmitChanges();
            }

            //funció per eliminar un tipus
            public void Eliminar(Tipus item)
            {
                DataClasses1DataContext dc = GetDC();
                dc.Tipus.Attach(item);
                dc.Tipus.DeleteOnSubmit(item);
                dc.SubmitChanges();
            }

            //funció per actualitzar un tipus
            public void Actualizar(Tipus nuevoItem, Tipus originalItem)
            {
                DataClasses1DataContext dc = GetDC();
                dc.Tipus.Attach(nuevoItem, originalItem);
                dc.SubmitChanges();
            }
        }
            #endregion
 }