﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Entidades;

namespace Datos
{
    public class UsuariTematicaDA : BaseDades, IDataAcces<UsuariTematica>
    {
            #region Miembros de IDataAccess<UsuariTematica>

            //funció per obtenir totes les temàtiques seleccionades per els usuaris
            public List<UsuariTematica> GetAll()
            {
                DataClasses1DataContext dc = GetDC();
                IQueryable<UsuariTematica> query = from usuariTematica
                                               in dc.UsuariTematica
                                               select usuariTematica;
                return ConsultaLista<UsuariTematica>(query);
            }

            //funció per afegir una nova temàtica a un usuari
            public void Adicionar(UsuariTematica item)
            {
                DataClasses1DataContext dc = GetDC();
                dc.UsuariTematica.InsertOnSubmit(item);
                dc.SubmitChanges();
            }

            //funció per eliminar una relació usuari-temàtica
            public void Eliminar(UsuariTematica item)
            {
                DataClasses1DataContext dc = GetDC();
                dc.UsuariTematica.Attach(item);
                dc.UsuariTematica.DeleteOnSubmit(item);
                dc.SubmitChanges();
            }

            //funció per actualitzar la temàtica d'un usuari
            public void Actualizar(UsuariTematica nuevoItem, UsuariTematica originalItem)
            {
                DataClasses1DataContext dc = GetDC();
                dc.UsuariTematica.Attach(nuevoItem, originalItem);
                dc.SubmitChanges();
            }

            //funció per a obtenir totes les temàtiques d'un usuari
            public List<UsuariTematica> GetUserTemes(int id)
            {
                DataClasses1DataContext dc = GetDC();
                                
                IQueryable<UsuariTematica> query = from usuariTematica
                                               in dc.UsuariTematica
                                           where usuariTematica.id_usuari==id
                                           select usuariTematica;

                return ConsultaLista<UsuariTematica>(query);
            }                 
        }
            #endregion
}