﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Entidades;
using Negoci;

namespace Presentacio
{
    public partial class Cercar : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            //Cotrolem que està registrat i si no enviem a pàgina de login
            if (HttpContext.Current.Session["UserId"] == null)
                Response.Redirect("Default.aspx");

        }

        protected void Button1_Click(object sender, EventArgs e)
        {
            UsuariBL bl = new UsuariBL();

            List<Usuari> usu = bl.SearchUser(TextBoxBuscador.Text);
            if (usu.Count == 0)
            {
                lblError.Text = "No existeix cap usuari amb aquestes dades";
                Repeater1.DataSource = null;
                Repeater1.DataBind();
            }
            else
            {
                lblError.Text = "";
                for (int i = 0; i < usu.Count; i++)
                {
                    if (usu.ElementAt(i).imatge == null)
                        usu.ElementAt(i).imatge = "noimatge.jpg";
                }

                Repeater1.DataSource = usu;
                Repeater1.DataBind();
            }
        }



        protected void Repeater1_ItemCommand(object source, RepeaterCommandEventArgs e)
        {
            //quan l'usuari vol afegir una amic, comprovem que nos ho són ja o que està pendent
            if (e.CommandName == "addFriend")
            {
                RepeaterItem item = (RepeaterItem)(((Button)(e.CommandSource)).NamingContainer);
                int friend = Convert.ToInt32(((Label)item.FindControl("Label2")).Text);
                if (!object.Equals(Session["UserId"], null))
                {
                    if (Object.Equals(Convert.ToInt32(Session["UserId"]), friend))
                    {
                        lblError.Text = "Your own profile";
                        lblError.Visible = true;
                    }
                    else
                    {
                        AmicsBL bl = new AmicsBL();
                        List<Amics> ListaAmics = bl.GetFriend(Convert.ToInt32(Session["UserId"]), Convert.ToInt32(friend));

                        if (ListaAmics.Count > 0)
                        {
                            foreach (Amics A in ListaAmics)
                            {
                                if (A.estat.ToString() == "1")
                                {
                                    lblError.Text = "Ja sou amics";
                                    lblError.Visible = true;
                                }
                                if (A.estat.ToString() == "0")
                                {
                                    lblError.Text = "Petició pendent de ser acceptada";
                                    lblError.Visible = true;
                                }
                                if (A.estat.ToString() == "2")
                                {
                                    lblError.Text = "Denegació d'amistat";
                                    lblError.Visible = true;
                                }
                            }
                        }
                        else
                        {
                            Amics amics = new Amics();
                            amics.id_usuari = Convert.ToInt32(Session["UserId"]);
                            amics.id_amic = Convert.ToInt32(friend);
                            amics.estat = 0;

                            bl.Adicionar(amics);

                            lblError.Text = "Petició d'amistat enviada";
                            lblError.Visible = true;
                        }
                    }
                }
                else
                {
                    Response.Redirect("~/Default.aspx");
                }
            }
            else
            {
                Response.Redirect("~/Default.aspx");
            }
        }
    }
}