﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Security.Cryptography;
using Negoci;
using Entidades;
using System.Text;

namespace Presentacio
{
    public partial class WebForm1 : System.Web.UI.Page
    {
        private List<Usuari> usuaris;

        protected void Page_Load(object sender, EventArgs e)
        {
            if (Session["UserId"] == null)
                Response.Redirect("Default.aspx");
            if (!IsPostBack)
            {
                if (Session["UserId"] != null)
                {

                    //carreguem les dades de l'usuari al formulari
                    UsuariBL usbl = new UsuariBL();

                    usuaris = usbl.GetUser(Convert.ToInt32(Session["UserId"]));

                    NomTxt.Text = usuaris.ElementAt(0).nom.ToString();
                    SurName.Text = usuaris.ElementAt(0).cognoms.ToString();
                    SexeList.Text = usuaris.ElementAt(0).sexe.ToString();
                    Phone.Text = usuaris.ElementAt(0).telefon.ToString();
                }
            }
            
        }

        protected void modificar_click(object sender, EventArgs e)
        {
            //Carreguem les dades actuals al objecte Usuari per actualitzar
            UsuariBL usbl = new UsuariBL();
            usuaris = usbl.GetUser(Convert.ToInt32(Session["UserId"]));
            Usuari usu = new Usuari();
            usu.id_usuari = Convert.ToInt32(usuaris.ElementAt(0).id_usuari);
            usu.id_perfil = Convert.ToInt32(usuaris.ElementAt(0).id_perfil);
            usu.imatge = usuaris.ElementAt(0).imatge.ToString();
            usu.nom = usuaris.ElementAt(0).nom.ToString();
            usu.cognoms = usuaris.ElementAt(0).cognoms.ToString();
            usu.sexe = usuaris.ElementAt(0).sexe;
            usu.telefon = usuaris.ElementAt(0).telefon.ToString();
            usu.email = usuaris.ElementAt(0).email.ToString();
            usu.pwd = usuaris.ElementAt(0).pwd.ToString();
            //Carreguem les dades del formulari al nou objecte Usuari
            Usuari usuNew = new Usuari();
            usuNew.id_usuari = Convert.ToInt32(usuaris.ElementAt(0).id_usuari);
            usuNew.id_perfil = Convert.ToInt32(usuaris.ElementAt(0).id_perfil);
            usuNew.imatge = usuaris.ElementAt(0).imatge.ToString();
            usuNew.nom = NomTxt.Text;
            usuNew.cognoms = SurName.Text;
            usuNew.sexe = Convert.ToChar(SexeList.SelectedValue);
            usuNew.telefon = Phone.Text;
            usuNew.email = usuaris.ElementAt(0).email.ToString();
            if (txtPwd.Text != "")
            {
                string md5pass = Md5encrypt(txtPwd.Text);
                usuNew.pwd = md5pass;
            }
            else
            {
                usuNew.pwd = usuaris.ElementAt(0).pwd.ToString();
            }

            UsuariBL bl = new UsuariBL();
            bl.Actualizar(usuNew, usu);

            lbl2Error.Text = "Les dades han estat actualitzades correctament";
        }

        //funció per encriptar la contrasenya amb MD5 avanç de guardar-la a la base de dades
        public string Md5encrypt(string strChange)
        {
            byte[] pass = Encoding.UTF8.GetBytes(strChange);
            MD5 md5 = new MD5CryptoServiceProvider();
            string strPassword = Encoding.UTF8.GetString(md5.ComputeHash(pass));
            return strPassword;
        } 
    }
}