﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Security.Cryptography;
using Negoci;
using Entidades;
using System.Text;

namespace Presentacio
{
    public partial class _Default : System.Web.UI.Page
    {
        private List<Usuari> usu;

        protected void Page_Load(object sender, EventArgs e)
        {

        }

        protected void Login1_Authenticate(object sender, AuthenticateEventArgs e)
        {
        }

        //funció per comprobar si existeix aquest usuari i amb aquesta contrasenya 
        protected void validar_click(object sender, EventArgs e)
        {
            try
            {                
                bool Authenticated = false;
                int id = 0;
                string md5pass = Md5encrypt(Password.Text);
                CheckBox chBox = RememberMe;
                UsuariBL bl = new UsuariBL();
                id = bl.GetUsuari(UserName.Text, md5pass);
                if (id > 0)
                {
                    Authenticated = true;
                    Session["UserId"] = id.ToString();
                    usu = bl.GetUser(id);
                    Session["UserRole"] = usu.ElementAt(0).id_perfil.ToString();
                }

                if (Authenticated == true)
                {
                    if (chBox.Checked == true)
                    {
                        Response.Cookies["UserEmail"].Value = UserName.Text;
                        Response.Cookies["UserPass"].Value = Md5encrypt(Password.Text);
                        Response.Cookies["UserUID"].Value = Session["UserId"].ToString();
                        Response.Cookies["UserEmail"].Expires = DateTime.Now.AddMonths(2);
                        Response.Cookies["UserPass"].Expires = DateTime.Now.AddMonths(2);
                        Response.Cookies["UserUID"].Expires = DateTime.Now.AddMonths(2);
                    }
                    Response.Redirect("~/Publicacions.aspx");
                }
                else
                {
                    lblError.Text = "Les dades no s'han introduït correctament, si us plau torna a validar-te";
                }
            }
            catch (Exception)
            {
                lblError.Text = "S'ha produït un error, si us plau reintenta l'operació";
            }

        }

        //funció per donar d'alta un usuari
        protected void registrar_click(object sender, EventArgs e)
        {
            try
            {
                //comprovem si ja existeix aquest mail a la bbdd
                UsuariBL blc = new UsuariBL();
                if(blc.GetUserEmail(EmailTxt.Text)==0)
                {
                    Usuari item = new Usuari();
                    item.email = EmailTxt.Text;
                    item.nom = NomTxt.Text;
                    item.pwd = Md5encrypt(txtPwd.Text);
                    item.cognoms = SurName.Text;
                    item.id_perfil = 2;//Els usuaris que es registren per aquí son usuaris normals de la xarxa id_perfil=2
                    item.sexe = Convert.ToChar(SexeList.SelectedItem.Value);
                    item.telefon = Phone.Text;

                    UsuariBL bl = new UsuariBL();
                    bl.Adicionar(item);

                    bool Authenticated = false;
                    int id = 0;
                    string md5pass = Md5encrypt(txtPwd.Text);
                    id = bl.GetUsuari(EmailTxt.Text, md5pass);
                    if (id > 0)
                    {
                        Authenticated = true;
                        Session["UserId"] = id.ToString();
                    }

                    if (Authenticated == true)
                    {
                        Response.Redirect("UserProfile.aspx");
                    }
                    else
                    {
                        lbl2Error.Text = "S'ha produït un error, si us plau reintenta l'operació";
                    }
                }
                else
                {
                    lbl2Error.Text = "Ja existeix un usuari amb aquest email";
                }

            }
            catch (Exception)
            {
                lbl2Error.Text = "S'ha produït un error, si us plau reintenta l'operació";
            }
        }

        //funció per encriptar la contrasenya amb MD5 avanç de afegir-la a la base de dades
        public string Md5encrypt(string strChange)
        {
            byte[] pass = Encoding.UTF8.GetBytes(strChange);
            MD5 md5 = new MD5CryptoServiceProvider();
            string strPassword = Encoding.UTF8.GetString(md5.ComputeHash(pass));
            return strPassword;
        } 

    }
}
