﻿using System;
using System.Data;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Collections;
using System.IO;
using System.Diagnostics;
using Negoci;
using Entidades;


namespace Presentacio
{
    public partial class _Publicacions : System.Web.UI.Page
    {
        private List<Publicacio> publicacions;
        private List<Usuari> usuaris;
        private List<Usuari> usuaris_c;
        private List<Comentari> comentaris;
        private List<Media> media;
        ArrayList arrValues = new ArrayList();

        protected void Page_Load(object sender, EventArgs e)
        {
            //Cotrolem que està registrat i si no enviem a pàgina de login
            if (HttpContext.Current.Session["UserId"] == null)
                Response.Redirect("Default.aspx");

            TematicaBL bl = new TematicaBL();
            List<Tematica> ListaTematiques = bl.GetAll();

            //afegim el primer item del dropdwonlist en blanc per a obligar a escollir un a l'usuari
            DropDownList1.Items.Add(new ListItem("Selecciona una temàtica...", ""));
            foreach (Tematica T in ListaTematiques)
                DropDownList1.Items.Add(new ListItem(T.descripcio, T.id_tematica.ToString()));

            //carreguem les publicacions
            cargarPublicacions();
            int profile_id = Convert.ToInt32(Session["UserId"]);
            GetUserDetails(profile_id);

        }

        //funció per afegir publicacions
        protected void Button1_Click(object sender, EventArgs e)
        {
            bool tipusError = false;
            int tipus = 0; //Per defecte tipus 0. No te ni videos ni imatges
            string videoTmpName = string.Empty;
            string imatgeTmpName = string.Empty;
            HttpPostedFile file = null;
            //Comprovem si ha afegit algún fitxer i en cas afirmatiu l'afegim
            if (FileUpload1.HasFile)
            {
                string videoOriginalPath = "~/Videos/Original/";
                string imatgePath = "~/Imatges/";



                file = FileUpload1.PostedFile;
                tipus = ValidateVideoExtension(file.FileName);
                if (tipus == 2)//Video
                {
                    //Verifiquem que el video no supera els 4MB
                    if (file.InputStream.Length > 4000000)
                    {
                        lblErrorVideo.Text = "La mida del fitxer supera els 4 MB";
                        tipusError = true;
                    }

                    //Verifiquem el tipus de fitxer

                    string saveAs = Server.MapPath(videoOriginalPath);
                    videoTmpName = Guid.NewGuid().ToString();
                    string originalVideo = saveAs + videoTmpName + new FileInfo(file.FileName).Extension;
                    file.SaveAs(originalVideo);

                    //Fem el encoding del video
                    if (EncodingVideo(originalVideo, videoTmpName))
                    {
                        //Response.Redirect("Publicacions.aspx");
                    }
                    else
                    {
                        lblErrorVideo.Text = "Error convertint el video, torna a intentar-ho";
                        tipusError = true;
                    }
                }
                else if (tipus == 1)//Foto
                {
                    string saveAs = Server.MapPath(imatgePath);
                    imatgeTmpName = Guid.NewGuid().ToString();
                    string originalImatge = saveAs + imatgeTmpName + new FileInfo(file.FileName).Extension;
                    file.SaveAs(originalImatge);
                }
                else
                {
                    lblErrorVideo.Text = "Extensió no permesa";
                    tipusError = true;
                }


            }
            //

            if (!tipusError)
            {
                PublicacioBL bl = new PublicacioBL();
                Publicacio NovaPublicacio = new Publicacio();
                NovaPublicacio.descripcio = TextBox1.Text;
                int ddl = Convert.ToInt32(DropDownList1.SelectedValue);
                NovaPublicacio.id_tematica = ddl;
                NovaPublicacio.data = DateTime.Now;
                NovaPublicacio.id_usuari = Convert.ToInt32(Session["UserId"].ToString());
                NovaPublicacio.id_tipus = tipus;

                int idPub = bl.AdicionarPublicacio(NovaPublicacio);
                //Si te video o foto l'afegin a la taula Media
                if (tipus > 0)
                {
                    MediaBL mbl = new MediaBL();
                    Media NouMedia = new Media();
                    NouMedia.id_tipus = tipus;
                    if (tipus == 2)
                        NouMedia.src_media = videoTmpName + ".flv";
                    else
                        NouMedia.src_media = imatgeTmpName + new FileInfo(file.FileName).Extension;
                    NouMedia.id_publicacio = idPub;
                    mbl.Adicionar(NouMedia);
                }
                if (idPub == 0)
                {
                    lblErrorVideo.Text = "Ha de introduir un nou comentari";
                    lblErrorVideo.Visible = true;
                }
                Response.Redirect("Publicacions.aspx");
            }
        }

        public void GetUserDetails(int id)
        {

            UsuariBL bl = new UsuariBL();
            List<Usuari> ListaUsuaris = bl.GetUser(id);
            foreach (Usuari U in ListaUsuaris)
            {
                if (U.imatge == null)
                    UserImage.ImageUrl = "~/UserImage/noimatge.jpg";
                else
                    UserImage.ImageUrl = "~/UserImage/" + U.imatge.ToString();

                LabelNom.Text = U.nom.ToString();
                LabelCognoms.Text = U.cognoms.ToString();
            }

        }

        protected void ButtonComment_Click(object sender, EventArgs e)
        {

        }

        protected void DropDownList1_SelectedIndexChanged(object sender, EventArgs e)
        {

        }


        protected void RepeaterPubli_ItemCommand(object source, RepeaterCommandEventArgs e)
        {

            if (e.CommandName == "addComment")
            {

                RepeaterItem item = (RepeaterItem)(((Button)(e.CommandSource)).NamingContainer);
                //string text = ((Label)item.FindControl("lblid12")).Text;
                Comentari com = new Comentari();
                com.id_publicacio = Convert.ToInt32(((Label)item.FindControl("id_publicacioLabel")).Text);
                com.id_usuari = Convert.ToInt32(Session["UserId"].ToString());
                com.comentari_text = ((TextBox)item.FindControl("ComentariText")).Text;
               // com.comentari_text = ((TextBox)RepeaterPubli.Items..Items[0].FindControl("ComentariText")).Text;

                ComentariBL bl = new ComentariBL();
                bl.Adicionar(com);

               
                List<Com> comment = new List<Com>();
                string image;
                ComentariBL cbl = new ComentariBL();
                comentaris = cbl.GetComentaris(Convert.ToInt32(com.id_publicacio));

                UsuariBL usbl = new UsuariBL();
                for (int j = 0; j < comentaris.Count(); j++)
                {
                    Com comm = new Com();
                    usuaris_c = usbl.GetUser(Convert.ToInt32(comentaris.ElementAt(j).id_usuari));
                    if (usuaris_c.ElementAt(0).imatge == null)
                        image = "noimatge.jpg";
                    else
                        image = usuaris_c.ElementAt(0).imatge.ToString();

                    comm.id_comentari = Convert.ToInt32(comentaris.ElementAt(j).id_comentari);
                    comm.id_publicacio = Convert.ToInt32(comentaris.ElementAt(j).id_publicacio);
                    comm.id_usuari = Convert.ToInt32(comentaris.ElementAt(j).id_usuari);
                    comm.comentari_text = comentaris.ElementAt(j).comentari_text.ToString();

                    comm.nomC = usuaris_c.ElementAt(0).nom.ToString();
                    comm.cognomsC = usuaris_c.ElementAt(0).cognoms.ToString();
                    comm.imatgeC = image;

                    comment.Add(comm);
                }

                Repeater RepeaterCom = (Repeater)e.Item.FindControl("RepeaterCom");

                RepeaterCom.DataSource = comment;
                RepeaterCom.DataBind();
                
                //vuidem el textbox després de afegir comentari
                ((TextBox)item.FindControl("ComentariText")).Text="";
            }

        }

        //Repeater que carrega els comentaris de les publicacions
        protected void RepeaterCom_ItemDataBound(object source, System.Web.UI.WebControls.RepeaterItemEventArgs e)
        {
            if (e.Item.ItemType == ListItemType.Item ||
            e.Item.ItemType == ListItemType.AlternatingItem)
            {
                Blog blog = (Blog)e.Item.DataItem;
                List<Com> comment = new List<Com>();
                string image;
                ComentariBL cbl = new ComentariBL();
                comentaris = cbl.GetComentaris(blog.id_publicacio);
                
                UsuariBL usbl = new UsuariBL();
                for (int j = 0; j < comentaris.Count(); j++)
                {
                    Com com = new Com();
                    usuaris_c = usbl.GetUser(Convert.ToInt32(comentaris.ElementAt(j).id_usuari));
                    if (usuaris_c.ElementAt(0).imatge == null)
                        image = "noimatge.jpg";
                    else
                        image = usuaris_c.ElementAt(0).imatge.ToString();

                    com.id_comentari = Convert.ToInt32(comentaris.ElementAt(j).id_comentari);
                    com.id_publicacio = Convert.ToInt32(comentaris.ElementAt(j).id_publicacio);
                    com.id_usuari = Convert.ToInt32(comentaris.ElementAt(j).id_usuari);
                    com.comentari_text = comentaris.ElementAt(j).comentari_text.ToString();

                    com.nomC = usuaris_c.ElementAt(0).nom.ToString();
                    com.cognomsC = usuaris_c.ElementAt(0).cognoms.ToString();
                    com.imatgeC = image;

                    comment.Add(com);
                }

                Repeater RepeaterCom = (Repeater)e.Item.FindControl("RepeaterCom");

                RepeaterCom.DataSource = comment;
                RepeaterCom.DataBind();
            }
        }

        //mètode per carregar les publicacions de l'usuari a la plana web
        protected void cargarPublicacions()
        {
            List<Blog> info = new List<Blog>();


            PublicacioBL bl = new PublicacioBL();
            publicacions = bl.GetFriendsAndUserPub(Convert.ToInt32(Session["UserId"])).ToList();

            string image;
            for (int i = 0; i < publicacions.Count(); i++)
            {//Carreguem la llista a la taula
                Blog blog = new Blog();
                UsuariBL ubl = new UsuariBL();
                usuaris = ubl.GetUser(publicacions.ElementAt(i).id_usuari);

                if (usuaris.ElementAt(0).imatge == null)
                    image = "noimatge.jpg";
                else
                    image = usuaris.ElementAt(0).imatge.ToString();

                blog.id_publicacio = Convert.ToInt32(publicacions.ElementAt(i).id_publicacio);
                blog.id_tematica = Convert.ToInt32(publicacions.ElementAt(i).id_tematica.ToString());
                blog.id_tipus = Convert.ToInt32(publicacions.ElementAt(i).id_tipus.ToString());
                blog.id_usuari = Convert.ToInt32(publicacions.ElementAt(i).id_usuari.ToString());
                blog.descripcio = publicacions.ElementAt(i).descripcio.ToString();
                blog.data = publicacions.ElementAt(i).data;

                blog.nom = usuaris.ElementAt(0).nom.ToString();
                blog.cognoms = usuaris.ElementAt(0).cognoms.ToString();
                blog.imatge = image;


                info.Add(blog);

            }


            RepeaterPubli.DataSource = info;
            RepeaterPubli.DataBind();

            for (int i = 0; i < publicacions.Count(); i++)
            {
                MediaBL mbl = new MediaBL();
                media = mbl.GetMediaPublicacio(Convert.ToInt32(publicacions.ElementAt(i).id_publicacio));
                if (media.Count > 0)
                {
                    for (int j = 0; j < media.Count; j++)
                    {
                        if (media.ElementAt(j).id_publicacio == Convert.ToInt32(publicacions.ElementAt(i).id_publicacio))
                        {
                            if (media.ElementAt(j).id_tipus == 2)
                            {
                                ((Label)RepeaterPubli.Items[i].FindControl("videoplayer")).Text = "<div id=\"test" + i.ToString() + "\" class=\"player" + i.ToString() + "\" href=\"Videos/Converted/" + media.ElementAt(j).src_media.ToString() + "\" runat=\"server\" style=\"display:block;width:320px;height:240px;border:solid 1px #e9e9e8;valign:center;align:center;background-color:#000000;\"><!-- Utilitzem imatge per a evitar l'inici automàtic del video --><img src=\"Player/flow_eye.jpg\" alt=\"Video\" style=\"margin:90px 130px;\" /></div>";
                                Page.ClientScript.RegisterStartupScript(this.GetType(), "video" + i.ToString(), "flowplayer(\"div.player" + i.ToString() + "\", \"Player/flowplayer-3.2.11.swf\");", true);
                            }
                            else
                            {
                                ((Label)RepeaterPubli.Items[i].FindControl("videoplayer")).Text = "<img src=\"Imatges/" + media.ElementAt(j).src_media.ToString() + "\"  style=\"display:block;width:320px;height:240px;border:solid 1px #e9e9e8;padding:4px;\" alt=\"Foto\" />";
                            }
                        }
                        else
                        {
                            ((Label)RepeaterPubli.Items[i].FindControl("videoplayer")).Text = "";
                        }
                    }
                }
            }

        }

        //funció per a validar l'extensió dels vídeos i les imatges
        private int ValidateVideoExtension(string filename)
        {
            FileInfo info = new FileInfo(filename);
            switch (info.Extension.ToLower())
            {
                case ".mpg":
                case ".wmv":
                case ".avi":
                case ".mp4":
                    return 2;
                case ".jpg":
                case ".png":
                case ".gif":
                    return 1;
                default:
                    return 0;
            }
        }

        //funció per convertir el vídeo al format flv amb ffmpeg.exe
        private bool EncodingVideo(string originalVideo, string videoTmpName)
        {
            bool value = false;
            string flv = ".flv";
            string videoConvertedName = string.Empty;
            string videoConvertedPath = "~/Videos/Converted/";
            string saveAs = Server.MapPath(videoConvertedPath);
            videoConvertedName = videoTmpName + flv;

            //Parametres que pasem a l'aplicació de encoding
            //string args = " -i \"" + originalVideo + "\" -b 200 -r 24 -s 320x240 -deinterlace -ab 64k \"" + saveAs + videoConvertedName + "\"";
            string args = " -i \"" + originalVideo + "\" -ar 22050 -ab 32 -f flv -s 320x240 -aspect 4:3 -y \"" + saveAs + videoConvertedName + "\"";
            //Utilitzem la classe proxy per accedir al executable
            using (Process encoding = new Process())
            {
                encoding.StartInfo.WorkingDirectory = Server.MapPath("~/");
                encoding.StartInfo.FileName = Server.MapPath("ffmpeg/ffmpeg.exe");
                encoding.StartInfo.Arguments = args;
                encoding.StartInfo.UseShellExecute = false;
                encoding.StartInfo.CreateNoWindow = true;
                encoding.StartInfo.RedirectStandardOutput = false;
                encoding.Start();
                //Hem de esperar a que finalitze el procés
                encoding.WaitForExit();
                value = true;
            }
            return value;
        }
    }
}
